Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/entities/MAP_STATUS.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/entities/MAP_STATUS.java	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/entities/MAP_STATUS.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -4,4 +4,4 @@
     PUBLIC,
     PRIVATE,
-    INVALID,
+    PENDING,
 }
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/entities/Report.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/entities/Report.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/entities/Report.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -0,0 +1,46 @@
+package internettehnologii.imaps.backendRender.web.entities;
+
+import jakarta.persistence.*;
+import lombok.Getter;
+import lombok.Setter;
+
+import java.time.LocalDateTime;
+
+@Entity
+@Table(name = "reports")
+@Getter
+@Setter
+public class Report {
+    @Id
+    @GeneratedValue(strategy = GenerationType.IDENTITY)
+    private int id;
+
+    @ManyToOne(fetch = FetchType.LAZY)
+    @JoinColumn(name = "user_id", nullable = false)
+    private IMapsUser user;
+
+    @ManyToOne(fetch = FetchType.LAZY)
+    @JoinColumn(name = "map_id", nullable = false)
+    private IndoorMap map;
+
+    @Column(nullable = false)
+    private String subject;
+
+    @Column(nullable = false, columnDefinition = "TEXT")
+    private String content;
+
+    @Column(name = "created_at", nullable = false)
+    private LocalDateTime createdAt;
+
+    public Report() {
+        this.createdAt = LocalDateTime.now();
+    }
+
+    public Report(IMapsUser user, IndoorMap map, String subject, String content) {
+        this.user = user;
+        this.map = map;
+        this.subject = subject;
+        this.content = content;
+        this.createdAt = LocalDateTime.now();
+    }
+}
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/repo/ReportRepository.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/repo/ReportRepository.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/repo/ReportRepository.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -0,0 +1,9 @@
+package internettehnologii.imaps.backendRender.web.repo;
+
+import internettehnologii.imaps.backendRender.web.entities.Report;
+import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.stereotype.Repository;
+
+@Repository
+public interface ReportRepository extends JpaRepository<Report, Integer> {
+}
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/repo/UserRepository.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/repo/UserRepository.java	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/repo/UserRepository.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -6,4 +6,5 @@
 import org.springframework.stereotype.Repository;
 
+import java.util.List;
 import java.util.Optional;
 
@@ -25,3 +26,8 @@
     value = "SELECT * FROM users u WHERE u.id= ?1")
     Optional<IMapsUser> getUserById(Long usrid);
+    @Query(value = "FROM IMapsUser u WHERE u.oAuthId = ?1")
+    Optional<IMapsUser> getUserByOAuthId(String oauthid);
+    @Query(nativeQuery = true,
+            value = "SELECT u.* FROM users u LEFT JOIN users_roles ur on u.id = ur.user_id where ur.role_id = 3;")
+    Optional<List<IMapsUser>> getAllAdmins();
 }
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/security/CorsConfigurationImpl.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/security/CorsConfigurationImpl.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/security/CorsConfigurationImpl.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -0,0 +1,57 @@
+package internettehnologii.imaps.backendRender.web.security;
+
+import org.springframework.context.annotation.Bean;
+import org.springframework.context.annotation.Primary;
+import org.springframework.context.annotation.Profile;
+import org.springframework.stereotype.Component;
+import org.springframework.web.cors.CorsConfiguration;
+import org.springframework.web.cors.CorsConfigurationSource;
+import org.springframework.web.cors.UrlBasedCorsConfigurationSource;
+
+@Component
+public class CorsConfigurationImpl {
+    private final CorsConfigurationSource corsConfigurationSource;
+
+    public CorsConfigurationImpl(CorsConfigurationSource corsConfigurationSource) {
+        this.corsConfigurationSource = corsConfigurationSource;
+    }
+
+    @Bean
+    @Profile("dev")
+    @Primary
+    public CorsConfigurationSource corsConfigurationSourceDev() {
+        CorsConfiguration configuration = new CorsConfiguration();
+        configuration.addAllowedOrigin("http://localhost:5173");
+        configuration.addAllowedMethod("*");
+        configuration.addAllowedHeader("*");
+        configuration.addAllowedHeader("*");
+        configuration.setAllowCredentials(true);
+
+        UrlBasedCorsConfigurationSource source = new UrlBasedCorsConfigurationSource();
+        source.registerCorsConfiguration("/**", configuration);
+
+        return source;
+    }
+
+    @Bean
+    @Profile("prod")
+    @Primary
+    public CorsConfigurationSource corsConfigurationSourceProd() {
+        CorsConfiguration configuration = new CorsConfiguration();
+        configuration.addAllowedOrigin("http://localhost");
+        configuration.addAllowedOrigin("https://imaps.mk");
+        configuration.addAllowedOrigin("https://www.imaps.mk");
+        configuration.addAllowedMethod("*");
+        configuration.addAllowedHeader("*");
+        configuration.setAllowCredentials(true);
+
+        UrlBasedCorsConfigurationSource source = new UrlBasedCorsConfigurationSource();
+        source.registerCorsConfiguration("/**", configuration);
+
+        return source;
+    }
+
+    public CorsConfigurationSource getCorsConfigurationSource() {
+        return corsConfigurationSource;
+    }
+}
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/security/JwtFilter.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/security/JwtFilter.java	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/security/JwtFilter.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -37,5 +37,9 @@
     protected void doFilterInternal(HttpServletRequest request, HttpServletResponse response, FilterChain filterChain) throws ServletException, IOException {
         System.out.println(request.getRequestURI());
-        if(request.getRequestURI().contains("/login") || request.getRequestURI().contains("/register")) {
+        if(
+                request.getRequestURI().contains("/login") ||
+                        request.getRequestURI().contains("/register") ||
+                        request.getMethod().equals("OPTIONS")
+        ) {
             filterChain.doFilter(request, response);
         }
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/security/WebSecurityConfig.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/security/WebSecurityConfig.java	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/security/WebSecurityConfig.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -5,4 +5,6 @@
 import org.springframework.context.annotation.Bean;
 import org.springframework.context.annotation.Configuration;
+import org.springframework.context.annotation.Primary;
+import org.springframework.context.annotation.Profile;
 import org.springframework.security.authentication.AuthenticationManager;
 import org.springframework.security.authentication.AuthenticationProvider;
@@ -15,4 +17,5 @@
 import org.springframework.security.config.http.SessionCreationPolicy;
 import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
+import org.springframework.security.crypto.password.PasswordEncoder;
 import org.springframework.security.web.SecurityFilterChain;
 import org.springframework.security.web.authentication.UsernamePasswordAuthenticationFilter;
@@ -28,6 +31,14 @@
     private MapUserDetailsService userDetailsService;
 
+    private final PasswordEncoder passwordEncoder;
+
     @Autowired
     private JwtFilter jwtFilter;
+    private final CorsConfigurationImpl corsConfiguration;
+
+    public WebSecurityConfig(PasswordEncoder passwordEncoder, CorsConfigurationImpl corsConfiguration) {
+        this.passwordEncoder = passwordEncoder;
+        this.corsConfiguration = corsConfiguration;
+    }
 
     @Bean
@@ -35,15 +46,13 @@
          http
                  .csrf(AbstractHttpConfigurer::disable)
-                 .cors(Customizer.withDefaults())
+                 .cors(cors -> cors.configurationSource(corsConfiguration.corsConfigurationSourceDev()))
                  .authorizeHttpRequests(request ->
-                         request.requestMatchers("/protected/**")
-                         .hasRole("USER")
-                         .requestMatchers("/api/admin/**")
-                         .hasRole("ADMIN")
-                         .anyRequest()
-                         .permitAll())
+                         request
+                                 .requestMatchers("/protected/**").hasRole("USER")
+                                 .requestMatchers("/api/admin/**").hasRole("ADMIN")
+                                 .anyRequest().permitAll())
+
                  .sessionManagement(session -> session.sessionCreationPolicy(SessionCreationPolicy.STATELESS))
                  .addFilterBefore(jwtFilter, UsernamePasswordAuthenticationFilter.class);
-         
 
         return http.build();
@@ -51,18 +60,4 @@
 
 
-    @Bean
-    public CorsConfigurationSource corsConfigurationSource() {
-        CorsConfiguration configuration = new CorsConfiguration();
-        configuration.addAllowedOrigin("http://localhost:5173/");
-        configuration.addAllowedMethod("*");
-        configuration.addAllowedHeader("*");
-        configuration.addAllowedHeader("*");
-        configuration.setAllowCredentials(true);
-
-        UrlBasedCorsConfigurationSource source = new UrlBasedCorsConfigurationSource();
-        source.registerCorsConfiguration("/**", configuration);
-
-        return source;
-    }
 
 
@@ -70,5 +65,5 @@
     public AuthenticationProvider authenticationProvider() {
         DaoAuthenticationProvider daoAuthenticationProvider = new DaoAuthenticationProvider();
-        daoAuthenticationProvider.setPasswordEncoder(new BCryptPasswordEncoder(12));
+        daoAuthenticationProvider.setPasswordEncoder(passwordEncoder);
         daoAuthenticationProvider.setUserDetailsService(userDetailsService);
         return daoAuthenticationProvider;
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/impl/GitHubOAuthService.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/impl/GitHubOAuthService.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/impl/GitHubOAuthService.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -0,0 +1,87 @@
+package internettehnologii.imaps.backendRender.web.service.impl;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+import internettehnologii.imaps.backendRender.web.controllers.InvalidStateException;
+import internettehnologii.imaps.backendRender.web.entities.IMapsUser;
+import internettehnologii.imaps.backendRender.web.entities.RBA.Role;
+import internettehnologii.imaps.backendRender.web.repo.RoleRepository;
+import internettehnologii.imaps.backendRender.web.repo.UserRepository;
+import internettehnologii.imaps.backendRender.web.service.interfaces.OAuthService;
+import internettehnologii.imaps.backendRender.web.util.DTO.GitHubUserInfo;
+import internettehnologii.imaps.backendRender.web.util.DTO.UserAuthSuccessDTO;
+import internettehnologii.imaps.backendRender.web.util.OAuthProviders;
+import internettehnologii.imaps.backendRender.web.util.UserPrincipal;
+import jakarta.transaction.Transactional;
+import org.springframework.security.crypto.password.PasswordEncoder;
+import org.springframework.stereotype.Service;
+
+import javax.management.relation.RoleNotFoundException;
+import java.util.Optional;
+
+@Service("githubOAuth")
+public class GitHubOAuthService implements OAuthService {
+    private final UserRepository userRepository;
+    private final PasswordEncoder passwordEncoder;
+    private final JWTService jwtService;
+    private final RoleRepository roleRepository;
+
+    public GitHubOAuthService(UserRepository userRepository, PasswordEncoder passwordEncoder, JWTService jwtService, RoleRepository roleRepository) {
+        this.userRepository = userRepository;
+        this.passwordEncoder = passwordEncoder;
+        this.jwtService = jwtService;
+        this.roleRepository = roleRepository;
+    }
+
+
+    @Override
+    @Transactional
+    public UserAuthSuccessDTO login(String userInfo, String accessToken) {
+        ObjectMapper mapper = new ObjectMapper();
+        GitHubUserInfo oAuthUserInfo;
+
+        try {
+            oAuthUserInfo = mapper.readValue(userInfo, GitHubUserInfo.class);
+        } catch (JsonProcessingException e) {
+            throw new RuntimeException("Failed to parse GitHub user info.", e);
+        }
+
+        Optional<IMapsUser> userOpt = userRepository.getUserByOAuthId(oAuthUserInfo.getId());
+        IMapsUser user = userOpt.orElseGet(() -> createNewUser(oAuthUserInfo));
+        user.setAccessToken(passwordEncoder.encode(accessToken));
+        userRepository.save(user);
+
+        String token = jwtService.generateToken(new UserPrincipal(user));
+
+        return new UserAuthSuccessDTO(
+                token,
+                user.getUsername(),
+                jwtService.getAuthorities(token).toString()
+        );
+    }
+
+    private IMapsUser createNewUser(GitHubUserInfo oAuthUserInfo) {
+        IMapsUser newUser = new IMapsUser();
+
+        newUser.setEmail(oAuthUserInfo.getEmail());
+        newUser.setOAuthId(oAuthUserInfo.getId());
+        newUser.setOAuthProvider(OAuthProviders.GITHUB.name());
+        newUser.setUsername(generateUniqueUsername(oAuthUserInfo));
+
+        Role userRole = roleRepository.findByName("USER")
+                .orElseThrow(() -> new RuntimeException("User role not found."));
+
+        userRole.getUsers().add(newUser);
+        newUser.getRoles().add(userRole);
+
+        return newUser;
+    }
+
+    private String generateUniqueUsername(GitHubUserInfo oAuthUserInfo) {
+        String login = oAuthUserInfo.getLogin();
+        String idSubstring = oAuthUserInfo.getId()
+                .substring(login.length() - 3, login.length() - 1);
+        return login + idSubstring;
+    }
+
+}
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/impl/GoogleOAuthService.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/impl/GoogleOAuthService.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/impl/GoogleOAuthService.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -0,0 +1,84 @@
+package internettehnologii.imaps.backendRender.web.service.impl;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+import internettehnologii.imaps.backendRender.web.entities.IMapsUser;
+import internettehnologii.imaps.backendRender.web.entities.RBA.Role;
+import internettehnologii.imaps.backendRender.web.repo.RoleRepository;
+import internettehnologii.imaps.backendRender.web.repo.UserRepository;
+import internettehnologii.imaps.backendRender.web.service.interfaces.OAuthService;
+import internettehnologii.imaps.backendRender.web.util.DTO.GitHubUserInfo;
+import internettehnologii.imaps.backendRender.web.util.DTO.GoogleUserInfo;
+import internettehnologii.imaps.backendRender.web.util.DTO.UserAuthSuccessDTO;
+import internettehnologii.imaps.backendRender.web.util.OAuthProviders;
+import internettehnologii.imaps.backendRender.web.util.UserPrincipal;
+import jakarta.transaction.Transactional;
+import org.springframework.security.crypto.password.PasswordEncoder;
+import org.springframework.stereotype.Service;
+
+import java.util.Optional;
+
+@Service("googleOAuth")
+public class GoogleOAuthService implements OAuthService {
+    private final UserRepository userRepository;
+    private final PasswordEncoder passwordEncoder;
+    private final JWTService jwtService;
+    private final RoleRepository roleRepository;
+
+    public GoogleOAuthService(UserRepository userRepository, PasswordEncoder passwordEncoder, JWTService jwtService, RoleRepository roleRepository) {
+        this.userRepository = userRepository;
+        this.passwordEncoder = passwordEncoder;
+        this.jwtService = jwtService;
+        this.roleRepository = roleRepository;
+    }
+
+    @Override
+    @Transactional
+    public UserAuthSuccessDTO login(String userInfo, String accessToken) {
+        ObjectMapper mapper = new ObjectMapper();
+        GoogleUserInfo oAuthUserInfo;
+
+        try {
+            oAuthUserInfo = mapper.readValue(userInfo, GoogleUserInfo.class);
+        } catch (JsonProcessingException e) {
+            throw new RuntimeException("Failed to parse Google user info.", e);
+        }
+
+        Optional<IMapsUser> userOpt = userRepository.getUserByOAuthId(oAuthUserInfo.getId());
+        IMapsUser user = userOpt.orElseGet(() -> createNewUser(oAuthUserInfo));
+        user.setAccessToken(passwordEncoder.encode(accessToken));
+        userRepository.save(user);
+
+        String token = jwtService.generateToken(new UserPrincipal(user));
+
+        return new UserAuthSuccessDTO(
+                token,
+                user.getUsername(),
+                jwtService.getAuthorities(token).toString()
+        );
+    }
+
+    private IMapsUser createNewUser(GoogleUserInfo oAuthUserInfo) {
+        IMapsUser newUser = new IMapsUser();
+
+        newUser.setEmail(oAuthUserInfo.getEmail());
+        newUser.setOAuthId(oAuthUserInfo.getId());
+        newUser.setOAuthProvider(OAuthProviders.GOOGLE.name());
+        newUser.setUsername(generateUniqueUsername(oAuthUserInfo));
+
+        Role userRole = roleRepository.findByName("USER")
+                .orElseThrow(() -> new RuntimeException("User role not found."));
+
+        userRole.getUsers().add(newUser);
+        newUser.getRoles().add(userRole);
+
+        return newUser;
+    }
+
+    private String generateUniqueUsername(GoogleUserInfo oAuthUserInfo) {
+        String username = oAuthUserInfo.getName();
+        String idSubstring = oAuthUserInfo.getId()
+                .substring(username.length() - 3, username.length() - 1);
+        return username + idSubstring;
+    }
+}
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/impl/MapServiceImpl.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/impl/MapServiceImpl.java	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/impl/MapServiceImpl.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -1,5 +1,8 @@
 package internettehnologii.imaps.backendRender.web.service.impl;
 
-import internettehnologii.imaps.backendRender.web.entities.*;
+import internettehnologii.imaps.backendRender.web.entities.Floor;
+import internettehnologii.imaps.backendRender.web.entities.IMapsUser;
+import internettehnologii.imaps.backendRender.web.entities.IndoorMap;
+import internettehnologii.imaps.backendRender.web.entities.MAP_STATUS;
 import internettehnologii.imaps.backendRender.web.exceptions.MapNameTakenException;
 import internettehnologii.imaps.backendRender.web.exceptions.MapNotFoundException;
@@ -8,4 +11,7 @@
 import internettehnologii.imaps.backendRender.web.repo.UserRepository;
 import internettehnologii.imaps.backendRender.web.service.interfaces.MapService;
+import internettehnologii.imaps.backendRender.web.util.DTO.EditMapDTO;
+import internettehnologii.imaps.backendRender.web.util.DTO.MapDTO;
+import jakarta.transaction.Transactional;
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.security.core.userdetails.UsernameNotFoundException;
@@ -31,5 +37,5 @@
 
     @Override
-    public void createMap(String mapName,String mapType, String username) {
+    public void createMap(String mapName, String username) {
 
         Optional<IMapsUser> user = userRepository.findUserByName(username);
@@ -38,5 +44,5 @@
             throw new MapNameTakenException("Map with name " + mapName + " already exists");
 
-        if(user.isEmpty()){
+        if (user.isEmpty()) {
             throw new UsernameNotFoundException("User " + username + " not found");
         }
@@ -58,4 +64,19 @@
     public void updateMap(IndoorMap indoorMap) {
         mapRepository.save(indoorMap);
+    }
+
+    @Transactional
+    @Override
+    public MapDTO updateMapInfo(EditMapDTO editMapDTO) {
+        IndoorMap indoorMap = mapRepository.getIndoorMapByName(editMapDTO.getInitialName()).orElseThrow(() -> new MapNotFoundException("Map with name " + editMapDTO.getInitialName() + " not found"));
+        if (mapRepository.existsByName(editMapDTO.getName()) && !Objects.equals(editMapDTO.getInitialName(), editMapDTO.getName())) {
+            throw new MapNameTakenException("Map with name " + editMapDTO.getName() + " already exists");
+        }
+
+        indoorMap.setName(editMapDTO.getName());
+        indoorMap.setGmapsUrl(editMapDTO.getGmapsUrl());
+//        indoorMap.setMapType(editMapDTO.getType()); //TODO
+        mapRepository.save(indoorMap);
+        return indoorMap.toMapDTO();
     }
 
@@ -85,5 +106,5 @@
         boolean isAdmin = user.getRoles().stream().anyMatch(role -> Objects.equals(role.getName(), "ADMIN"));
 
-        if(isAdmin){
+        if (isAdmin) {
             return map;
         }
@@ -99,5 +120,5 @@
     @Override
     public IndoorMap getMapByName(String mapName) {
-       return mapRepository.getIndoorMapByName(mapName).orElseThrow(() -> new MapNotFoundException(mapName));
+        return mapRepository.getIndoorMapByName(mapName).orElseThrow(() -> new MapNotFoundException(mapName));
     }
 
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/impl/OAuthStateStore.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/impl/OAuthStateStore.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/impl/OAuthStateStore.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -0,0 +1,24 @@
+package internettehnologii.imaps.backendRender.web.service.impl;
+
+import internettehnologii.imaps.backendRender.web.service.interfaces.StateStore;
+import org.springframework.stereotype.Service;
+
+import java.util.Map;
+import java.util.concurrent.ConcurrentHashMap;
+
+@Service
+public class OAuthStateStore implements StateStore {
+
+    private final Map<String, Long> stateStore = new ConcurrentHashMap<>();
+
+    @Override
+    public void storeState(String state) {
+        stateStore.put(state, System.currentTimeMillis());
+    }
+
+    @Override
+    public boolean isValidState(String state) {
+        Long timestamp = stateStore.remove(state);
+        return timestamp != null && System.currentTimeMillis() - timestamp < 300000; // 5min
+    }
+}
Index: imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/impl/PublishRequestServiceImpl.java
===================================================================
--- imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/impl/PublishRequestServiceImpl.java	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-backend/backendRender/src/main/java/internettehnologii/imaps/backendRender/web/service/impl/PublishRequestServiceImpl.java	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -7,8 +7,13 @@
 import internettehnologii.imaps.backendRender.web.repo.MapRepository;
 import internettehnologii.imaps.backendRender.web.repo.PublishRequestRepository;
+import internettehnologii.imaps.backendRender.web.repo.UserRepository;
 import internettehnologii.imaps.backendRender.web.service.interfaces.MapService;
 import internettehnologii.imaps.backendRender.web.service.interfaces.PublishRequestService;
 import internettehnologii.imaps.backendRender.web.service.interfaces.UserService;
+import internettehnologii.imaps.backendRender.web.util.DTO.MapDTO;
 import internettehnologii.imaps.backendRender.web.util.DTO.PublishMapDTO;
+import jakarta.transaction.Transactional;
+import org.springframework.mail.SimpleMailMessage;
+import org.springframework.mail.javamail.JavaMailSender;
 import org.springframework.stereotype.Service;
 
@@ -22,14 +27,18 @@
     private final MapService mapService;
     private final UserService userService;
+    //private final JavaMailSender mailSender;
+    private final UserRepository userRepository;
 
-    public PublishRequestServiceImpl(PublishRequestRepository publishRequestRepository, MapRepository mapRepository, MapService mapService, UserService userService) {
+    public PublishRequestServiceImpl(PublishRequestRepository publishRequestRepository, MapRepository mapRepository, MapService mapService, UserService userService, UserRepository userRepository) {
         this.publishRequestRepository = publishRequestRepository;
         this.mapRepository = mapRepository;
         this.mapService = mapService;
         this.userService = userService;
+        this.userRepository = userRepository;
     }
 
     @Override
-    public void addPublishRequest(PublishMapDTO formData, IMapsUser user) {
+    @Transactional
+    public MapDTO addPublishRequest(PublishMapDTO formData, IMapsUser user) {
         Optional<PublishRequest> prOptional = publishRequestRepository.findById(formData.getId());
         PublishRequest pr;
@@ -41,20 +50,21 @@
             pr.setGMapsUrl(formData.getGoogleMapsUrl());
             pr.setMapType(formData.getMapType());
-            map.setStatus(MAP_STATUS.INVALID);
+            map.setStatus(MAP_STATUS.PENDING);
         } else {
             pr = new PublishRequest(formData.getName(), formData.getLastName(), formData.getGoogleMapsUrl(), formData.getMapType());
-
             pr.setMap(map);
             pr.setUser(user);
-            map.setStatus(MAP_STATUS.INVALID);
+            map.setStatus(MAP_STATUS.PENDING);
 
         }
         this.mapRepository.save(map);
         this.publishRequestRepository.save(pr);
+        sendMailToAdmins(user,pr);
+        return map.toMapDTO();
 
     }
 
     @Override
-    public void denyPublishRequest(int id) throws Exception {
+    public void denyPublishRequest(int id,String reason) throws Exception {
         PublishRequest pr = this.publishRequestRepository.findById(id).orElseThrow(Exception::new);
 
@@ -66,4 +76,12 @@
         this.publishRequestRepository.save(pr);
         this.mapRepository.save(map);
+
+//        SimpleMailMessage message = new SimpleMailMessage();
+//
+//        message.setTo(pr.getMap().getUser().getEmail());
+//        message.setSubject("Denied Publish Request");
+//        message.setText(String.format("Your publish request for map: %s has been denied." +
+//                "\nReason:\n%s",pr.getMap().getName(),reason));
+//        mailSender.send(message);
     }
 
@@ -77,6 +95,39 @@
 
     }
+    @Override
+    public void sendMailToAdmins(IMapsUser user, PublishRequest pr){
+//        System.out.println("test");
+//        SimpleMailMessage message = new SimpleMailMessage();
+//        Optional<List<IMapsUser>> adminsOpt = userRepository.getAllAdmins();
+//        adminsOpt.ifPresent(admins -> {
+//            admins.forEach(admin -> {
+//                message.setTo(admin.getEmail());
+//                message.setSubject("New Publish Request");
+//                String body = String.format(
+//                        """
+//                                Publish Request Details:
+//                                \tRequest Id: %s
+//                                \tMap Id: %s
+//                                \tMap Name: %s
+//
+//                                User Details:
+//                                \tId: %s
+//                                \tUsername: %s
+//                                \tEmail: %s
+//                                \tFirst Name: %s
+//                                \t Last Name: %s
+//                                """,
+//                        pr.getId(), pr.getMap().getId(),
+//                        pr.getMap().getName(),
+//                        user.getId(),user.getUsername(),user.getEmail(),
+//                        pr.getName(),pr.getLastName());
+//
+//                message.setText(body);
+//                mailSender.send(message);
+//            });
+//        });
 
-    // todo mail pustanje
+    }
+
 
     @Override
@@ -93,4 +144,11 @@
         this.publishRequestRepository.save(pr);
         this.mapRepository.save(map);
+
+//        SimpleMailMessage message = new SimpleMailMessage();
+//        message.setTo(pr.getMap().getUser().getEmail());
+//        message.setSubject("Approved Publish Request");
+//        message.setText(String.format("Your publish request for map: %s has been approved!\nYour map is now public. That means that anyone can view and use your map.\nThank you for building!",pr.getMap().getName()));
+//        mailSender.send(message);
+
     }
 
